// 
//
#define WIN32_LEAN_AND_MEAN
#include "Chapt1.h"
#include <windows.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <math.h>

#define DRAWING

int iii=0;

const bool EnableZBuffer=false;
const bool TripleBuffering=false;

float ScreenWidth=640;
float ScreenHeight=480;
GrScreenResolution_t grRes=GR_RESOLUTION_640x480;

#define ViewX(X) (ScreenWidth/2+(X+xs)*scx)
#define ViewY(Y) (ScreenHeight/2+(Y+ys)*scy)

#define CoordToVertex(V,X,Y) {V.x=ScreenWidth/2+((X)+xs)*scx*cos(ang)-((Y)+ys)*scy*sin(ang); V.y=ScreenHeight/2+((Y)+ys)*scy*cos(ang)+((X)+xs)*scx*sin(ang);}
//#define CoordToVertex(V,X,Y) {V.x=ViewX(X); V.y=ViewY(Y);}

float z0=0;

HWND hWnd;

char FileName[1024]="E:\\Alexandr\\ \\Metafile\\Metaedit\\WMF\\answmach.wmf";

int InStr(int start,const char *s,char symbol) {
	int i,l=strlen(s);
	for (i=start;i<l;i++)
		if (symbol==s[i]) return i;
	return -1;
}

/*int LoadTex(char *filename,GrMipMapId_t *decal0)
{
Gu3dfInfo         info;

	if ( !gu3dfGetInfo( filename , &info ) )  
	{
		fprintf(stderr, "ERROR: could not load texture \n");
		grGlideShutdown();
		return -1;
	}
	else
	{
		info.data = malloc( info.mem_required );

		if ( info.data == 0 ) {
			fprintf( stderr, "out of memory for texture\n" );
			grGlideShutdown();
			return -1;
		}

		if ( !gu3dfLoad( filename , &info ) ) {
			fprintf( stderr, "could not load texture file\n" );
			grGlideShutdown();
			return -1;
		}

		*decal0 = guTexAllocateMemory( 0, GR_MIPMAPLEVELMASK_BOTH,
											  info.header.width, info.header.height,
											  info.header.format,
											  GR_MIPMAP_NEAREST,
											  info.header.small_lod, info.header.large_lod,
											  info.header.aspect_ratio,
											  GR_TEXTURECLAMP_WRAP, GR_TEXTURECLAMP_WRAP,
											  GR_TEXTUREFILTER_BILINEAR, GR_TEXTUREFILTER_BILINEAR,
											  0.0F,
											  FXFALSE );
		if ( *decal0 == GR_NULL_MIPMAP_HANDLE ) {
			fprintf( stderr, "could not allocate memory for Texture\n" );
			grGlideShutdown();
			return -1;
		}
		guTexDownloadMipMap( *decal0, info.data, &info.table.nccTable );
		free( info.data );
	}
}*/

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{

 if (strlen(lpCmdLine)) strcpy(FileName,lpCmdLine);

 WNDCLASS	wc;
 
 MSG		Msg;

 wc.style         = CS_HREDRAW | CS_VREDRAW;
 wc.lpfnWndProc   = WindowProc;
 wc.cbClsExtra    = 0;
 wc.cbWndExtra    = 0;
 wc.hInstance     = hInstance;
 wc.hIcon         = LoadIcon(NULL, IDI_APPLICATION);
 wc.hCursor       = LoadCursor(NULL, IDC_ARROW); //  
 wc.hbrBackground = NULL;                        //  
 wc.lpszMenuName  = NULL;                        //    
 wc.lpszClassName = "Glide";
 RegisterClass(&wc);
 hWnd = CreateWindow("Glide",
                     "GlideWMF",
                     WS_POPUP,
                     0, 0,
                     GetSystemMetrics(SM_CXSCREEN),
                     GetSystemMetrics(SM_CYSCREEN),
                     NULL,
                     NULL,
                     hInstance,
                     NULL);
 if (hWnd == NULL)
  return 1;
 ShowWindow(hWnd, nCmdShow);
 while (GetMessage(&Msg, NULL, 0, 0))
 {TranslateMessage(&Msg);
  DispatchMessage(&Msg);
 }
 return 0;
}
//-----------------------------------------------------------------------------
//
LRESULT CALLBACK WindowProc(HWND hWnd,
                            UINT uMsg,
                            WPARAM wParam,
                            LPARAM lParam)
{switch (uMsg)
 {case WM_CREATE:
   if (!Start(hWnd))
    return -1;
   return 0;
  case WM_DESTROY:
   ShutDown();
   PostQuitMessage(0);
   return 0;
  case WM_SETCURSOR:
   SetCursor(FALSE);
   return TRUE;
  case WM_KEYUP:
   if (wParam == VK_ESCAPE)
    DestroyWindow(hWnd);
   return 0;
 }
 return DefWindowProc(hWnd, uMsg, wParam, lParam);
}
//---------------------------------------------------------------------------
// "" 3DFX
bool Start(HWND hWnd)
{//      3dfx
	if (!grGet(GR_NUM_BOARDS, sizeof(Num3Dfx), &Num3Dfx)) return false;
	char ScrMode[16];
	FILE *devcfg=fopen("Device.cfg","rt");
	if (devcfg) {
		fscanf(devcfg,"%s",ScrMode);
		fclose(devcfg);	
		if (strlen(ScrMode)>=7) {
			if (!strcmp(ScrMode,"320x240")) {grRes=GR_RESOLUTION_320x240; ScreenWidth=320; ScreenHeight=240;}
			if (!strcmp(ScrMode,"400x300")) {grRes=GR_RESOLUTION_400x300; ScreenWidth=400; ScreenHeight=300;}
			if (!strcmp(ScrMode,"512x384")) {grRes=GR_RESOLUTION_512x384; ScreenWidth=512; ScreenHeight=384;}
			if (!strcmp(ScrMode,"640x480")) {grRes=GR_RESOLUTION_640x480; ScreenWidth=640; ScreenHeight=480;}
			if (!strcmp(ScrMode,"800x600")) {grRes=GR_RESOLUTION_800x600; ScreenWidth=800; ScreenHeight=600;}
			if (!strcmp(ScrMode,"960x720")) {grRes=GR_RESOLUTION_960x720; ScreenWidth=960; ScreenHeight=720;}
			if (!strcmp(ScrMode,"1024x768")) {grRes=GR_RESOLUTION_1024x768; ScreenWidth=1024; ScreenHeight=768;}
			if (!strcmp(ScrMode,"1600x1200")) {grRes=GR_RESOLUTION_1600x1200; ScreenWidth=1600; ScreenHeight=1200;}
		}
	}
	#ifdef DRAWING
		grGlideInit();
		grSstSelect(0);
		Context = grSstWinOpen((FxU32)hWnd,             //  
								grRes,					// 
								GR_REFRESH_85Hz,        //  
								GR_COLORFORMAT_ABGR,    //  
								GR_ORIGIN_UPPER_LEFT,	//   (0,0)
								TripleBuffering?3:2,    //  
								EnableZBuffer?1:0);     //    Z-
		if (Context == NULL) return false;
	#endif
	if (!Drawing()) return false;
	return true;
}

// 
void ShutDown()
{
	#ifdef DRAWING
		grSstWinClose(Context);
		grGlideShutdown();
	#endif
}

float SetGamma(float gamma) {
	float g=gamma;
	if (g<0.125) g=0.125;
	if (g>8) g=8;
	#ifdef DRAWING
		guGammaCorrectionRGB(g,g,g);
	#endif
	return g;
}

float DefaultGamma() {
	float g;
	FILE *fg=fopen("Settings.cfg","rt");
	if (fg) {
		fscanf(fg,"%f",&g);
		fclose(fg);
	} else g=1.2;
	return SetGamma(g);
}

//  
bool Drawing()
{

	DWORD BeginTime=GetTickCount();
	DWORD Frames=0;

	HANDLE hFile=CreateFile(FileName, GENERIC_READ, 0, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0);

	DWORD ret;
	WORD *Buf;
	DWORD FileSize=GetFileSize(hFile,&ret);
	//if (FileSize>0) MessageBeep(0);		

	if ((FileSize)&&(FileSize<=1024*1024*1024)&&(!ret)) {

		Buf=new WORD [(FileSize+1)/2];
		ReadFile(hFile,Buf,FileSize,&ret,NULL);

		#ifdef DRAWING

			grColorCombine( GR_COMBINE_FUNCTION_SCALE_OTHER,
                GR_COMBINE_FACTOR_ONE,
                GR_COMBINE_LOCAL_NONE,
                GR_COMBINE_OTHER_TEXTURE,
                FXFALSE );

				//   -
			 grAlphaCombine(GR_COMBINE_FUNCTION_SCALE_OTHER, //   -
							GR_COMBINE_FACTOR_ONE,           // 
							GR_COMBINE_LOCAL_NONE,           //
							GR_COMBINE_OTHER_ITERATED,       //
							FXFALSE);                        //   -

			 grAlphaBlendFunction(GR_BLEND_SRC_ALPHA,
								  GR_BLEND_ONE_MINUS_SRC_ALPHA,
								  GR_BLEND_ZERO,
								  GR_BLEND_ZERO);

			 //  Z-
			if (EnableZBuffer) {
				grDepthBufferMode(GR_DEPTHBUFFER_ZBUFFER);      //  Z-
				grDepthBufferFunction(GR_CMP_GREATER);
				grDepthMask(FXTRUE);
			}
 
			grCoordinateSpace(GR_WINDOW_COORDS);
			//     
			grVertexLayout(GR_PARAM_XY, 0, GR_PARAM_ENABLE);	//   X, Y
			//grVertexLayout(GR_PARAM_Z, 8, GR_PARAM_ENABLE);		// Z 
			grVertexLayout(GR_PARAM_RGB, 12, GR_PARAM_ENABLE);	//   RGB
			grVertexLayout(GR_PARAM_A, 24, GR_PARAM_ENABLE);	// -
			grVertexLayout(GR_PARAM_ST0, 28, GR_PARAM_ENABLE);	// -

			 //  
			grBufferClear( 0, 0, 0 );

		#endif

		float scx=0.25;
		float scy=0.25;
		float xs=0;
		float ys=0;
		float ang=0;
		bool AA=true;
		int CircDetail=50;
		float Gamma;

		Gamma=DefaultGamma();

		float cf=3.141592654/CircDetail;
		DWORD t=GetTickCount();
		DWORD dt=0;
		POINT mcp;

		Gu3dfInfo fileInfo;
		gu3dfGetInfo("test.3df",&fileInfo);
		fileInfo.data=malloc(fileInfo.mem_required);
		gu3dfLoad("test.3df",&fileInfo);
		FILE *f=fopen("file.txt","wt");
		fprintf(f,"%i",fileInfo.mem_required);
		fclose(f);


		FxU32 textureSize[2], startAddress[2];

		startAddress[0] = grTexMinAddress(GR_TMU0);
		startAddress[1] = grTexMinAddress(GR_TMU1);

		GrTexInfo tri;
		tri.data=fileInfo.data;//malloc(fileInfo.mem_required);
		//memcpy(tri.data,fileInfo.data,fileInfo.mem_required);
		tri.smallLodLog2=fileInfo.header.small_lod;
		tri.largeLodLog2=fileInfo.header.large_lod;
		tri.aspectRatioLog2=fileInfo.header.aspect_ratio;
		tri.format=fileInfo.header.format;

		grTexDownloadMipMap(GR_TMU0,startAddress[0],GR_MIPMAPLEVELMASK_ODD,&tri);
		grTexCombine( GR_TMU0,GR_COMBINE_FUNCTION_LOCAL,GR_COMBINE_FACTOR_NONE,GR_COMBINE_FUNCTION_LOCAL,GR_COMBINE_FACTOR_NONE,FXFALSE, FXFALSE);
		
		grTexSource(GR_TMU0,startAddress[0],GR_MIPMAPLEVELMASK_BOTH, &tri);

		grTexClampMode(GR_TMU0,GR_TEXTURECLAMP_WRAP,GR_TEXTURECLAMP_WRAP);

		
		do {

			
			t+=(dt=GetTickCount()-t*1.);

			int i,j,k;
			float objz=1;
			float f,a,b,x,y;

			if (Frames%1==0) {
				if (1&GetAsyncKeyState(65)) AA=!AA;
				if (GetAsyncKeyState(107)||GetAsyncKeyState(1)) {scx*=1.01; scy*=1.01;}
				if (GetAsyncKeyState(109)||GetAsyncKeyState(2)) {scx/=1.01; scy/=1.01;}
				if (scx>1) scx=1;
				if (scy>1) scy=1;
				/*if (GetAsyncKeyState(37)) xs+=10;
				if (GetAsyncKeyState(39)) xs-=10;
				if (GetAsyncKeyState(38)) ys+=10;
				if (GetAsyncKeyState(40)) ys-=10;*/
				if (GetAsyncKeyState(100)) ang+=0.01;
				if (GetAsyncKeyState(101)) ang=0;
				if (GetAsyncKeyState(102)) ang-=0.01;
				if (GetAsyncKeyState(36)) Gamma=DefaultGamma();
				if (GetAsyncKeyState(35)) {
					FILE *fg=fopen("Settings.cfg","wt");
					if (fg) {
						fprintf(fg,"%f",Gamma);
						fclose(fg);
					}
				}
				f=1;
				if (GetAsyncKeyState(33)) f*=1.01;
				if (GetAsyncKeyState(34)) f/=1.01;
				if (f!=1) Gamma=SetGamma(Gamma*f);
				GetCursorPos(&mcp);
				xs=10*(ScreenWidth/2-mcp.x); ys=10*(ScreenHeight/2-mcp.y);
			}

			#ifdef DRAWING
				grBufferClear( 0, 0, 0 );
				if (AA) grEnable(GR_AA_ORDERED); else grDisable(GR_AA_ORDERED);   // -
				myVertex vtx1={xs,ys,1,255,255,255,255,0,0};
				myVertex vtx2={xs+512,ys,1,255,255,255,255,255,0};
				myVertex vtx3={xs+512,ys+512,1,255,255,255,255,255,255};
				myVertex vtx4={xs,ys+512,1,255,255,255,255,0,255};

				//grDrawTriangle(&vtx3,&vtx4,&vtx1);
				
				
				//grTexDownloadMipMap(GR_TMU1,startAddress[1],GR_MIPMAPLEVELMASK_EVEN,&tri);
				//grTexSource(GR_TMU1,startAddress[1],GR_MIPMAPLEVELMASK_EVEN, &tri);
				//grTexCombine( GR_TMU1,GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,GR_COMBINE_FUNCTION_LOCAL, GR_COMBINE_FACTOR_NONE,FXFALSE, FXFALSE );
				grDrawTriangle(&vtx3,&vtx4,&vtx1);
				grDrawTriangle(&vtx1,&vtx2,&vtx3);
				
				grBufferSwap(1);
			#endif
			Frames++;
		} while (!GetAsyncKeyState(27));
		CloseHandle(hFile);
		
	}

	ShutDown();

	DWORD EndTime=GetTickCount();

	FILE *fps=fopen("fps.txt","wt");
	fprintf(fps,"%i",1000*Frames/(EndTime-BeginTime));
	fclose(fps);

	DestroyWindow(hWnd);	
	return true;
}